#define FBD_CXP_ADDR_HOST_DL_CONTROL                     0x1038
#define FBD_CXP_ADDR_HOST_UL_CONTROL                     0x0030
#define FBD_CXP_VALUE_HOST_CONTROL_GLOBAL_RESET          0x80000000

#define FBD_CXP_ADDR_HOST_DL_STATUS                      0x1000
#define FBD_CXP_MASK_HOST_DL_STATUS_FIFO_SPACES          0x000000FF
#define FBD_CXP_VALUE_HOST_DL_STATUS_ACK_PENDING         0x00002000
#define FBD_CXP_VALUE_HOST_DL_STATUS_FIFO_OVERFLOW       0x00004000
#define FBD_CXP_VALUE_HOST_DL_STATUS_LINK_ACTIVE         0x00008000

#define FBD_CXP_ADDR_HOST_UL_STATUS                      0x0000
#define FBD_CXP_MASK_HOST_UL_STATUS_FIFO_SPACES          0x000000FF
#define FBD_CXP_VALUE_HOST_UL_STATUS_FIFO_OVERFLOW       0x00000100

#define FBD_CXP_ADDR_IRQ_CONTROL                         0x1004
#define FBD_CXP_VALUE_IRQ_CONTROL_LINK_STATUS_CHANGE_EN  0x01000000
#define FBD_CXP_VALUE_IRQ_CONTROL_ACK_EN                 0x02000000
#define FBD_CXP_VALUE_IRQ_CONTROL_GPIO_EN                0x04000000
#define FBD_CXP_VALUE_IRQ_CONTROL_GLOBAL_EN              0x80000000

#define FBD_CXP_ADDR_IRQ_STATUS                          0x1014
#define FBD_CXP_MASK_IRQ_STATUS_QUEUE_LEVEL              0x000000FF
#define FBD_CXP_VALUE_IRQ_STATUS_EVENT_PENDING           0x40000000
#define FBD_CXP_VALUE_IRQ_STATUS_EVENT_QUEUE_OVERFLOW    0x80000000

#define FBD_CXP_ADDR_IRQ_QUEUE                           0x1018
#define FBD_CXP_MASK_IRQ_QUEUE_GPIO_MESSAGE_DATA         0x000000FF
#define FBD_CXP_VALUE_IRQ_QUEUE_GPIO_MESSAGE_EVENT       0x00010000
#define FBD_CXP_VALUE_IRQ_QUEUE_ACK_EVENT                0x00020000
#define FBD_CXP_VALUE_IRQ_QUEUE_LINK_STATUS_CHANGE_EVENT 0x80000000

#define FBD_CXP_ADDR_TO_DEVICE_FIFO                      0x0008
#define FBD_CXP_ADDR_TO_HOST_FIFO                        0x1010
#define FBD_CXP_MASK_FIFO_DATA_BYTE_P0                   0x000000FF
#define FBD_CXP_MASK_FIFO_DATA_BYTE_P1                   0x0000FF00
#define FBD_CXP_MASK_FIFO_DATA_BYTE_P2                   0x00FF0000
#define FBD_CXP_MASK_FIFO_DATA_BYTE_P3                   0xFF000000

#define FBD_CXP_ADDR_TO_DEVICE_ADDRESS                   0x0010

#define FBD_CXP_ADDR_TO_DEVICE_COMMAND                   0x000C
#define FBD_CXP_MASK_TO_DEVICE_COMMAND_BYTE_COUNT        0x00FFFFFF
#define FBD_CXP_MASK_TO_DEVICE_COMMAND_COMMAND           0xFF000000
#define FBD_CXP_VALUE_TO_DEVICE_COMMAND_READ             0x00000000
#define FBD_CXP_VALUE_TO_DEVICE_COMMAND_WRITE            0x01000000
#define FBD_CXP_VALUE_TO_DEVICE_COMMAND_RESET            0xFF000000

#define FBD_CXP_ADDR_TO_HOST_BYTE_COUNT                  0x100C

#define FBD_CXP_ADDR_TO_HOST_ACK                         0x1008
#define FBD_CXP_VALUE_TO_HOST_ACK_READ_OK                0x00
#define FBD_CXP_VALUE_TO_HOST_ACK_WRITE_OK               0x01
#define FBD_CXP_VALUE_TO_HOST_TENTATIVE_ACK              0x02
#define FBD_CXP_VALUE_TO_HOST_RST_OK                     0x03
#define FBD_CXP_VALUE_TO_HOST_WAIT_ACK                   0x04
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_ADDRESS      0x40
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_DATA         0x41
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_CONTOL       0x42
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_WRITE        0x43
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_READ         0x44
#define FBD_CXP_VALUE_TO_HOST_ERROR_SIZE_TOO_LARGE       0x45
#define FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_SIZE         0x46
#define FBD_CXP_VALUE_TO_HOST_ERROR_INCORERCT_CRC        0x80

#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_SIZE_MISMATCH    (0x80000000 | FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_SIZE)
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_STATUS_MISMATCH  (0x80000000 | FBD_CXP_VALUE_TO_HOST_ERROR_INCORERCT_CRC)
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_COMMAND_MISMATCH (0x80000000 | FBD_CXP_VALUE_TO_HOST_ERROR_INVALID_CONTOL)

#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_ACK_TIMEOUT           0x80000100
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_WAIT_ACK_TIMEOUT      0x80000200
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_USER_ACK_TIMEOUT      0x80000400
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_INITIAL_ACK_TIMEOUT   0x80000800
#define FBD_CXP_ASL_VALUE_TO_HOST_ERROR_TENTATIVE_ACK_TIMEOUT 0x80001000

