#define ASLDMA_VERSION_STRING "3.2.0.0"
#define ASLDMA_VERSION 0x03020000

#define ASLDMA_MAX_DEVICES 1024
#define ASLDMA_MAX_EVENTS 1024

struct asldma_event{
   struct list_head this_event;
   MDA_IoctlEvent   event;
};

struct asldma_device {
   struct module *       owner;
   struct mda_device *   mdadev;
   struct device *       device;
   struct cdev           cdev;
   dev_t                 major;
   dev_t                 minor;
   enum baseboard_type   baseboard_type;

   int                   open_count;
   struct file *         file_write_exclusive;
   spinlock_t            open_lock;

   int                   fpga_reprogramming;

   struct list_head      dma_buffer_list;
   spinlock_t            dma_buffer_list_lock;

   struct list_head      event_free_list;
   struct list_head      event_pending_list;
   spinlock_t            event_list_lock;
   wait_queue_head_t     event_wait_queue_head;
   uint32_t              event_queue_overflow_count;
   uint32_t              event_fifo_overflow_count;
   size_t                event_list_size;
   mda_sequence_t        event_sequence_number;
   uint32_t              event_abort_reason;
   struct asldma_event * events;
};
#define	to_mda_dma(dev) container_of(dev, struct asldma_device, device)

#define MDADMA_EVENT_ABORT_REASON_CLOSED 1

irqreturn_t asldma_isr(struct mda_device *dma_device, void *data);
void asldma_stop_risc_engine(struct asldma_device *dma_device);
