#include "precomp.h"

#if defined CONFIG_64BIT || defined CONFIG_X86
/* 64 bit atomic operations supported on 64 bit processors
 * and 32 bit Intel X86 processors
 */
void MdaResetSequenceNumber(mda_sequence_t * pSequenceNumber)
{
   atomic64_set(pSequenceNumber, 0);
   return;
}

uint64_t MdaGetSequenceNumber(mda_sequence_t * pSequenceNumber)
{
   return (uint64_t)(atomic64_inc_return(pSequenceNumber) - 1);
}

#else

void MdaResetSequenceNumber(mda_sequence_t * pSequenceNumber)
{
   atomic_set(pSequenceNumber, 0);
   return;
}

uint64_t MdaGetSequenceNumber(mda_sequence_t * pSequenceNumber)
{
   return (uint64_t)(atomic_inc_return(pSequenceNumber) - 1);
}

#endif


