#include "precomp.h"

typedef struct {
   uint32_t uiMemOffset;
   uint32_t uiIrqMask;
} stDeviceInfo;

static stDeviceInfo Acq1 = { 0x000C0000, 0x00000001 };
static stDeviceInfo Acq2 = { 0x002C0000, 0x00000002 };
static stDeviceInfo Acq3 = { 0x004C0000, 0x00000004 };
static stDeviceInfo Acq4 = { 0x006C0000, 0x00000008 };
static stDeviceInfo Acq5 = { 0x008C0000, 0x00000010 };
static stDeviceInfo Acq6 = { 0x00AC0000, 0x00000020 };
 
static stDeviceInfo Cxp1 = { 0x00088000, 0x00000001 };
static stDeviceInfo Cxp2 = { 0x00288000, 0x00000002 };
static stDeviceInfo Cxp3 = { 0x00488000, 0x00000004 };
static stDeviceInfo Cxp4 = { 0x00688000, 0x00000008 };
static stDeviceInfo Cxp40= { 0x00688000, 0 };
static stDeviceInfo Cxp50= { 0x00888000, 0 };
static stDeviceInfo Cxp60= { 0x00A88000, 0 };

static stDeviceInfo Cls1 = { 0x00080000, 0x00000001 };
static stDeviceInfo Cls2 = { 0x00280000, 0x00000002 };
static stDeviceInfo Cls3 = { 0x00480000, 0x00000004 };
static stDeviceInfo Cls4 = { 0x00680000, 0x00000008 };
static stDeviceInfo Cls5 = { 0x00880000, 0x00000010 };
static stDeviceInfo Cls6 = { 0x00A80000, 0x00000020 };
static stDeviceInfo Cls7 = { 0x00C80000, 0x00000040 };

/*static stDeviceInfo Gio1 = { 0x00090000, 0x00000001 };*/

static stDeviceInfo* apsDmaDev[6] = { &Acq1, &Acq2, &Acq3, &Acq4, &Acq5, &Acq6 };
static stDeviceInfo* apsClsDev[4] = { &Cls1, &Cls2, &Cls3, &Cls4 };
static stDeviceInfo* aps4Dev13[3] = { &Cls1, &Cls2, &Cls3 };
static stDeviceInfo* aps4Dev24[3] = { &Cls2, &Cls3, &Cls4 };
static stDeviceInfo* aps4Dev35[3] = { &Cls3, &Cls4, &Cls5 };
static stDeviceInfo* aps2Dev4 [1] = { &Cls4 };
static stDeviceInfo* aps2Dev45[2] = { &Cls4, &Cls5 };
static stDeviceInfo* aps2Dev5 [1] = { &Cls5 };
static stDeviceInfo* aps2Dev56[2] = { &Cls5, &Cls6 };
static stDeviceInfo* aps2Dev6 [1] = { &Cls6 };
static stDeviceInfo* aps2Dev67[2] = { &Cls6, &Cls7 };
static stDeviceInfo* apsCxpDev[4] = { &Cxp1, &Cxp2, &Cxp3, &Cxp4 };
static stDeviceInfo* apsCxpDev12[2] = { &Cxp1, &Cxp40 };
static stDeviceInfo* apsCxpDev36[6] = { &Cxp1, &Cxp40, &Cxp2, &Cxp50, &Cxp3, &Cxp60 };
/*static stDeviceInfo* apsGioDev[1] = { &Gio1 };*/

 struct {
 char *pDescription; uint32_t vendor; uint32_t sub_vendor; uint32_t device; uint32_t sub_device; uint32_t revision;
 uint32_t channels; uint32_t _dma; uint32_t _cls; uint32_t _485; uint32_t _232; uint32_t _cxp; uint32_t _gio;
 void *ppsDmaDev; void *ppsClsDev; void *pps485Dev; void *pps232Dev; void *ppsCxpDev; void *ppsGioDev;
} firebird_config [] = {                                                                                                  /* d cl  4  2 cx  g */
   {"FBD_1XCLD_2PE8"             , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB01_ID, 0   , 1, 1, 1, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_2PE8_TTLA"        , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB08_ID, 0   , 5, 1, 1, 3, 1, 0, 0, &apsDmaDev, &apsClsDev, &aps4Dev24, &aps2Dev5,       NULL,       NULL},
   {"FBD_1XCLD_2PE8_MIR"         , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB0B_ID, 0   , 6, 1, 1, 3, 2, 0, 0, &apsDmaDev, &apsClsDev, &aps4Dev24, &aps2Dev56,      NULL,       NULL},
   {"FBD_4XCXP6_2PE8"            , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB02_ID, 0   , 4, 4, 0, 0, 0, 4, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_4XCXP12_3PE4"           , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_KU_3PE4_DEVICE_ID, FBD_SUBSYSTEM_FB15_ID, 0   , 4, 4, 0, 0, 0, 4, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_4XCXP12_3PE8"           , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_KU_3PE8_DEVICE_ID, FBD_SUBSYSTEM_FB19_ID, 0   , 4, 4, 0, 0, 0, 4, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_2XCLD_2PE8"             , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB03_ID, 0   , 2, 2, 2, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLM_2PE8"             , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB04_ID, 0   , 2, 2, 2, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLM_2PE8_TTLA"        , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB0A_ID, 0   , 6, 2, 2, 3, 1, 0, 0, &apsDmaDev, &apsClsDev, &aps4Dev35, &aps2Dev6,       NULL,       NULL},
   {"FBD_1XCLM_2PE8_MIR"         , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB0D_ID, 0   , 7, 2, 2, 3, 2, 0, 0, &apsDmaDev, &apsClsDev, &aps4Dev35, &aps2Dev67,      NULL,       NULL},
   {"FBD_2XCLM_2PE8"             , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB05_ID, 0   , 4, 4, 4, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_2XCXP6_2PE8"            , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB06_ID, 0   , 2, 2, 0, 0, 0, 2, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_1XCXP6_2PE8"            , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB07_ID, 0   , 1, 1, 0, 0, 0, 1, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_1XCXP6_2PE8_REV01"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB07_ID, 0x01, 2, 2, 0, 0, 0, 1, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev12,     NULL},
   {"FBD_4XCXP6_2PE8_REV01"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB02_ID, 0x01, 6, 6, 0, 0, 0, 3, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev36,     NULL},
   {"FBD_4XCXP6_2PE8_REV02"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB02_ID, 0x02, 4, 4, 0, 0, 0, 4, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_4XCXP6_2PE8_REV03"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB02_ID, 0x03, 4, 4, 0, 0, 0, 4, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_4XCXP6_2PE8_TTLA"       , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB09_ID, 0   , 8, 4, 0, 3, 1, 4, 0, &apsDmaDev,       NULL, &aps4Dev13, &aps2Dev4, &apsCxpDev,       NULL},
   {"FBD_2XCXP6_2PE8_REV01"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB06_ID, 0x01, 2, 2, 0, 0, 0, 2, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_4XCXP6_2PE8_MIR"        , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB0C_ID, 0   , 9, 4, 0, 3, 2, 4, 0, &apsDmaDev,       NULL, &aps4Dev13, &aps2Dev45,&apsCxpDev,       NULL},
   {"FBD_1XCXP6_2PE8LR1"         , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_V6_2PE8_DEVICE_ID, FBD_SUBSYSTEM_FB0E_ID, 0   , 1, 1, 0, 0, 0, 1, 0, &apsDmaDev,       NULL,       NULL,      NULL, &apsCxpDev,       NULL},
   {"FBD_1XCLD_2PE4_ISS01"       , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB0F_ID, 0   , 1, 1, 1, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_2PE4"             , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB10_ID, 0   , 1, 1, 1, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_2PE4_REV01"       , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB10_ID, 0x01, 2, 2, 2, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
/* {"FBD_1XCLD_2PE4_SW"          , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB11_ID, 0   , 1, 1, 1, 0, 0, 0, 1, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL, &apsGioDev},*/
/* {"FBD_1XCLD_2PE4_SW_REV01"    , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB11_ID, 0x01, 2, 2, 2, 0, 0, 0, 1, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL, &apsGioDev},*/
   {"FBD_1XCLD_2PE4L"            , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB12_ID, 0   , 1, 1, 1, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_2PE4L_REV01"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB12_ID, 0x01, 2, 2, 2, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_3CPCIS_2PE4"      , FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB13_ID, 0   , 1, 1, 1, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   {"FBD_1XCLD_3CPCIS_2PE4_REV01", FBD_XILINX_VENDOR_ID, FBD_SUBVENDOR_ID, FBD_A7_2PE4_DEVICE_ID, FBD_SUBSYSTEM_FB13_ID, 0x01, 2, 2, 2, 0, 0, 0, 0, &apsDmaDev, &apsClsDev,       NULL,      NULL,       NULL,       NULL},
   { NULL                        , 0     , 0     , 0     , 0     , 0   , 0, 0, 0, 0, 0, 0, 0,       NULL,       NULL,       NULL,      NULL,       NULL,       NULL}
};

void aslenum_get_fbd_config_desc( uint32_t index, void *desc )
{
   *(char **)desc = firebird_config[index].pDescription;
}

void aslenum_get_fbd_config_device( uint32_t index, void *device )
{
   *(uint32_t *)device = firebird_config[index].device;
}

void aslenum_get_fbd_config_revision( uint32_t index, void *revision )
{
   *(uint32_t *)revision = firebird_config[index].revision;
}

void aslenum_get_fbd_config_sub_device( uint32_t index, void *sub_device )
{
   *(uint32_t *)sub_device = firebird_config[index].sub_device;
}

void aslenum_get_fbd_config_sub_vendor( uint32_t index, void *sub_vendor )
{
   *(uint32_t *)sub_vendor = firebird_config[index].sub_vendor;
}

void aslenum_get_fbd_config_vendor( uint32_t index, void *vendor )
{
   *(uint32_t *)vendor = firebird_config[index].vendor;
}

void aslenum_get_num_channels( uint32_t index, void *channels )
{
   *(uint32_t *)channels = firebird_config[index].channels;
}

void aslenum_get_num_232_channels( uint32_t index, void *_232 )
{
   *(uint32_t *)_232 = firebird_config[index]._232;
}

void aslenum_get_num_485_channels( uint32_t index, void *_485 )
{
   *(uint32_t *)_485 = firebird_config[index]._485;
}

void aslenum_get_num_cls_channels( uint32_t index, void *_cls )
{
   *(uint32_t *)_cls = firebird_config[index]._cls;
}

void aslenum_get_num_cxp_channels( uint32_t index, void *_cxp )
{
   *(uint32_t *)_cxp = firebird_config[index]._cxp;
}

void aslenum_get_num_dma_channels( uint32_t index, void *_dma )
{
   *(uint32_t *)_dma = firebird_config[index]._dma;
}

void aslenum_get_num_gio_channels( uint32_t index, void *_gio )
{
   *(uint32_t *)_gio = firebird_config[index]._gio;
}

void aslenum_get_acq_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo Acq = **((stDeviceInfo **)firebird_config[index].ppsDmaDev + i);

   *(uint32_t *)mem_offset = Acq.uiMemOffset;
   *(uint32_t *)irq_mask   = Acq.uiIrqMask;
}

void aslenum_get_cls_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo Cls = **((stDeviceInfo **)firebird_config[index].ppsClsDev + i);

   *(uint32_t *)mem_offset = Cls.uiMemOffset;
   *(uint32_t *)irq_mask   = Cls.uiIrqMask;
}

void aslenum_get_cxp_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo Cxp = **((stDeviceInfo **)firebird_config[index].ppsCxpDev + i);

   *(uint32_t *)mem_offset = Cxp.uiMemOffset;
   *(uint32_t *)irq_mask   = Cxp.uiIrqMask;
}

void aslenum_get_gio_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo Gio = **((stDeviceInfo **)firebird_config[index].ppsGioDev + i);

   *(uint32_t *)mem_offset = Gio.uiMemOffset;
   *(uint32_t *)irq_mask   = Gio.uiIrqMask;
}

void aslenum_get_485_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo _485 = **((stDeviceInfo **)firebird_config[index].pps485Dev + i);

   *(uint32_t *)mem_offset = _485.uiMemOffset;
   *(uint32_t *)irq_mask   = _485.uiIrqMask;
}

void aslenum_get_232_info( uint32_t index, uint32_t i, void *mem_offset, void *irq_mask )
{
   stDeviceInfo _232 = **((stDeviceInfo **)firebird_config[index].pps232Dev + i);

   *(uint32_t *)mem_offset = _232.uiMemOffset;
   *(uint32_t *)irq_mask   = _232.uiIrqMask;
}

EXPORT_SYMBOL(aslenum_get_fbd_config_desc);
EXPORT_SYMBOL(aslenum_get_fbd_config_device);
EXPORT_SYMBOL(aslenum_get_fbd_config_revision);
EXPORT_SYMBOL(aslenum_get_fbd_config_sub_device);
EXPORT_SYMBOL(aslenum_get_fbd_config_sub_vendor);
EXPORT_SYMBOL(aslenum_get_fbd_config_vendor);
EXPORT_SYMBOL(aslenum_get_num_channels);
EXPORT_SYMBOL(aslenum_get_num_232_channels);
EXPORT_SYMBOL(aslenum_get_num_485_channels);
EXPORT_SYMBOL(aslenum_get_num_cls_channels);
EXPORT_SYMBOL(aslenum_get_num_cxp_channels);
EXPORT_SYMBOL(aslenum_get_num_dma_channels);
/*EXPORT_SYMBOL(aslenum_get_num_gio_channels);*/
EXPORT_SYMBOL(aslenum_get_acq_info);
EXPORT_SYMBOL(aslenum_get_cls_info);
EXPORT_SYMBOL(aslenum_get_cxp_info);
/*EXPORT_SYMBOL(aslenum_get_gio_info);*/
EXPORT_SYMBOL(aslenum_get_485_info);
EXPORT_SYMBOL(aslenum_get_232_info);
