#ifndef _ASL_SYS_IOCTL_H
#define _ASL_SYS_IOCTL_H

#include "mda_linux.h"

#define _MDASYS_IOCTL(_n)              _IOWR( MDASYSTEM_TYPE, ( MDASYSTEM_FCMIN              + (_n) ), mda_io_buffer )
#define _MDASYS_EVENTQ_IOCTL(_n)       _IOWR( MDASYSTEM_TYPE, ( MDA_SYSTEM_EVENT_QUEUE_FCMIN + (_n) ), mda_io_buffer )
#define _MDASYS_DEBUGQ_IOCTL(_n)       _IOWR( MDASYSTEM_TYPE, ( MDA_SYSTEM_DEBUG_QUEUE_FCMIN + (_n) ), mda_io_buffer )
#define _MDASYS_LOCK_IOCTL(_n)         _IOWR( MDASYSTEM_TYPE, ( MDA_IOCTL_SYSTEM_LOCK_FCMIN  + (_n) ), mda_io_buffer )
#define _MDASYS_VARS_IOCTL(_n)         _IOWR( MDASYSTEM_TYPE, ( MDA_IOCTL_SYSTEM_VARS_FCMIN  + (_n) ), mda_io_buffer )

#define MDAEVENTQUEUE_FUNCTION_PUT     0
#define MDAEVENTQUEUE_FUNCTION_GET     1
#define MDAEVENTQUEUE_FUNCTION_CLEAR   2
#define MDALOCK_FUNCTION_ACQUIRE_LOCK  0
#define MDALOCK_FUNCTION_RELEASE_LOCK  1
#define MDALOCK_FUNCTION_SET_TIMEOUT   2
#define MDAVARS_FUNCTION_SET_SIZE      0


/* lpvInBuffer  = NULL
 * lpvOutBuffer = PULONG
 */
#define MDA_IOCTL_GET_VERSION                _MDASYS_IOCTL( 0x01 )

/* lpvInBuffer  = NULL
 * lpvOutBuffer = PULONG
 */
#define MDA_IOCTL_GET_UNIQUE_ID              _MDASYS_IOCTL( 0x02 )


/* lpvInBuffer  = pRegList
 * lpvOutBuffer = pRegList
 */
#define MDA_IOCTL_SYSTEM_REGLIST             _MDASYS_IOCTL( 0x03 )



/* lpvInBuffer  = NULL
 * lpvOutBuffer = PULONG
 */
#define MDA_IOCTL_SYSTEM_EVENT_GET           _MDASYS_EVENTQ_IOCTL( MDAEVENTQUEUE_FUNCTION_GET )


/* lpvInBuffer  = PULONG
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_EVENT_PUT           _MDASYS_EVENTQ_IOCTL( MDAEVENTQUEUE_FUNCTION_PUT )


/* lpvInBuffer  = NULL
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_EVENT_CLEAR         _MDASYS_EVENTQ_IOCTL( MDAEVENTQUEUE_FUNCTION_CLEAR )



/* lpvInBuffer  = NULL
 * lpvOutBuffer = PULONG
 */
#define MDA_IOCTL_SYSTEM_DEBUG_QUEUE_GET     _MDASYS_DEBUGQ_IOCTL( MDAEVENTQUEUE_FUNCTION_GET )


/* lpvInBuffer  = PULONG
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_DEBUG_QUEUE_PUT     _MDASYS_DEBUGQ_IOCTL( MDAEVENTQUEUE_FUNCTION_PUT )


/* lpvInBuffer  = NULL
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_DEBUG_QUEUE_CLEAR   _MDASYS_DEBUGQ_IOCTL( MDAEVENTQUEUE_FUNCTION_CLEAR )


/* lpvInBuffer  = NULL
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_LOCK_ACQUIRE_LOCK   _MDASYS_LOCK_IOCTL( MDALOCK_FUNCTION_ACQUIRE_LOCK )


/* lpvInBuffer  = NULL
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_LOCK_RELEASE_LOCK   _MDASYS_LOCK_IOCTL( MDALOCK_FUNCTION_RELEASE_LOCK )


/* lpvInBuffer  = PULONG Timeout in ms. Default = 0
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_LOCK_SET_TIMEOUT    _MDASYS_LOCK_IOCTL( MDALOCK_FUNCTION_SET_TIMEOUT )


/* lpvInBuffer  = PULONG Size in bytes. Default = 4
 * lpvOutBuffer = NULL
 */
#define MDA_IOCTL_SYSTEM_VARS_SET_SIZE       _MDASYS_VARS_IOCTL( MDAVARS_FUNCTION_SET_SIZE )

#endif

